#include <stdio.h>
#include <stdbool.h>
#include <stdlib.h>

typedef struct _arrPlus {
    double *arr;
    int length;
} ArrayPlus;

void arpDelete(ArrayPlus *a) {
    if (a == NULL) {
        return;
    }

    if (a->arr != NULL) {
        free(a->arr);
    }

    free(a);
}

ArrayPlus *arpCreate(int size) {
    if (size < 0) {
        return NULL;
    }

    ArrayPlus *A = (ArrayPlus *)malloc(sizeof(ArrayPlus));
    if (A == NULL) {
        return NULL;
    }

    A->length = size;
    A->arr = (double *)malloc( size * sizeof(double) );
    if (A->arr == NULL) {
        arpDelete(A);
        return NULL;
    }

    return A;
}

bool arpResize(ArrayPlus *a, int newSize) {
    if (newSize < 0 || a == NULL) {
        return false;
    }

    double *help = (double *)realloc(a->arr, newSize * sizeof(double));
    if (help == NULL) {
        return false;
    }

    a->arr = help;
    a->length = newSize;

    return true;
}

int main( )
{
    printf("Hello, World!\n");
    return 0;
}
